#ifndef __SHOW_CORBA_H__
#define __SHOW_CORBA_H__

#ifdef CLEAN_ORB_MICO
#define MICO_CONF_DYNANY
#include "CORBA-SMALL.h"
#endif

#ifdef CLEAN_ORB_ORBACUS
#include <OB/CORBA.h>
#endif

// ----------------------------------------------------------------------
// CORBA2 macro
// ----------------------------------------------------------------------

// this macro is used to access CORBA module definitions
#define CORBA2(IDENT) CORBA::IDENT

#define CORBA2_DynAny DynamicAny::DynAny
#define CORBA2_DynAny_ptr DynamicAny::DynAny_ptr
#define CORBA2_DynAny_var DynamicAny::DynAny_var

#define CORBA2_DynEnum DynamicAny::DynEnum
#define CORBA2_DynEnum_var DynamicAny::DynEnum_var

#define CORBA2_DynArray DynamicAny::DynArray
#define CORBA2_DynArray_ptr DynamicAny::DynArray_ptr
#define CORBA2_DynArray_var DynamicAny::DynArray_var

#define CORBA2_DynSequence DynamicAny::DynSequence
#define CORBA2_DynSequence_ptr DynamicAny::DynSequence_ptr
#define CORBA2_DynSequence_var DynamicAny::DynSequence_var

#define CORBA2_DynStruct DynamicAny::DynStruct
#define CORBA2_DynStruct_ptr DynamicAny::DynStruct_ptr
#define CORBA2_DynStruct_var DynamicAny::DynStruct_var

#define CORBA2_DynUnion DynamicAny::DynUnion
#define CORBA2_DynUnion_var DynamicAny::DynUnion_var

#define CORBA2_AnySeq  DynamicAny::AnySeq
#define CORBA2_AnySeq_var  DynamicAny::AnySeq_var

#define CORBA2_NameValuePairSeq_var DynamicAny::NameValuePairSeq_var

// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
//
// a class to display CORBA::TypeCode and CORBA::DynAny instances
//
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------

class CORBA_OUT
{
protected: // internal state

   int level_;
   ostream& ostr_;
   CORBA2(ORB_ptr) orb_;
   DynamicAny::DynAnyFactory_ptr fac_;

public: // constructor and destructor

   CORBA_OUT (ostream& ostr)
     : level_(0), ostr_ (ostr), orb_(0), fac_(0) {};
   ~CORBA_OUT () {};

public: // manage level

   void set_orb (CORBA2(ORB_ptr) orb) { orb_ = orb; };
   void set_fac (DynamicAny::DynAnyFactory_ptr fac) { fac_ = fac; };
   void down () { level_ ++; };
   void up () { level_ --; };

   ostream& skip () {
       for(int i=0; i<level_; i++) ostr_ << "   ";
       return ostr_;
   };

public:

   void display_IDL_TypeCode (CORBA2(TypeCode_ptr));
   void show_name_TypeCode (CORBA2(TypeCode_ptr));

   void display_DynAny (CORBA2_DynAny_ptr);
   void show_DynAny_without_type (CORBA2_DynAny_ptr);
   void show_DynAny (CORBA2_DynAny_ptr);
   void display_Any (const CORBA2(Any)&);
   void show_Any (const CORBA2(Any)&);

   void display_AnySeq (CORBA2_AnySeq* any_seq);
};

#endif // __SHOW_CORBA_H__
